

/**
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * @author Z. Pan
 * @version 1.0
 */
import edu.lehigh.swat.bench.ubt.api.*;
import edu.lehigh.swat.hawk.owl.*;
import edu.lehigh.swat.hawk.storage.dldb.DldbStorage;
//import edu.lehigh.swat.hawk.storage.ontper.simpledb.PerDbStorage;
//import edu.lehigh.swat.hawk.storage.simpledb.Query;
//import edu.lehigh.swat.hawk.storage.simpledb.Atom;
import java.io.*;
import java.net.*;
import java.util.*;
import edu.lehigh.swat.hawk.core.*;
import edu.lehigh.swat.hawk.storage.*;


public class HawkRepository implements edu.lehigh.swat.bench.ubt.api.Repository {

  DldbStorage kb;
  OwlRdfReader reader;
  String ontology = "";

  public HawkRepository() {

  }

  public void open(String s){
    kb = new DldbStorage(s);
    kb.open();
    kb.setQueryOntology(ontology);
    try{
      reader = new OwlRdfReader(kb);
    }catch(Exception e){

    }
  }

  public void close(){
    kb.close();
  }

  public QueryResult issueQuery(edu.lehigh.swat.bench.ubt.api.Query q){
    try{
      edu.lehigh.swat.hawk.storage.simpledb.Query query
          = new edu.lehigh.swat.hawk.storage.simpledb.Query();
      Vector v = q.getAtoms();
      Iterator it = v.iterator();
      while(it.hasNext()){
       edu.lehigh.swat.bench.ubt.api.Atom a = (edu.lehigh.swat.bench.ubt.api.Atom)it.next();
       edu.lehigh.swat.hawk.storage.simpledb.Atom atom = new edu.lehigh.swat.hawk.storage.simpledb.Atom(a.getPredicate(),a.getArguments());
       query.addConjunct(atom);
      }
      ResultSet rs = kb.issueQuery(query);
      HawkResults result = new HawkResults(rs);
      return result;
    }
    catch(Exception e){
      e.printStackTrace();
      return null;
    }

  }

  public boolean load(String dataPath){
    try{
      File dir = new File(dataPath);
      String[] list = dir.list();
      if (list == null) {
        System.err.println("Invalid data directory: " + dataPath);
        return false;
      }
      for (int i = 0; i < list.length; i++) {
        String file = "file:///" +dataPath + "/" + list[i];
        reader.read(file);
        System.out.println("End loading " + file);
      }
    }
    catch (Exception e) {
      e.printStackTrace();
      System.exit(-1);
    }
    return true;
  }

  public void setOntology(String url){
    ontology = url;
  }

  public void clear(){
  }

}
