
import edu.lehigh.swat.hawk.owl.*;
import edu.lehigh.swat.hawk.storage.dldb.DldbStorage;
import edu.lehigh.swat.hawk.storage.ontper.simpledb.PerDbStorage;
import edu.lehigh.swat.hawk.storage.simpledb.DatabaseStorage;
import java.io.*;
import java.net.*;
import java.util.*;
import edu.lehigh.swat.hawk.core.*;
import edu.lehigh.swat.hawk.storage.*;
/**
 * test case
 * @author Z. Pan
 * @version 1.0
 */
public class TestDB {

  static DldbStorage storage;

  public TestDB() {
  }

  public static void main(String[] args) {
    try{
      if(args.length!=3){
        System.out.println("Usage: TestDB dbFile urlFile reasonerUrl [u|f]");
      }
 //   String url = args[0];
//    String xmlBase = args[1];
    String dbpath = args[0];
    String filename = args[1];
    String rurl = args[2];
    TestDB test = new TestDB();
    storage = new DldbStorage(dbpath);
    storage.open();
    storage.setReasonerUrl(rurl);
    OwlRdfReader reader = new OwlRdfReader(storage);
    reader.setLoadImports(true);
    if(args[3].equals("u"))
      reader.read(filename);
    else{
      BufferedReader br = new BufferedReader(new FileReader(filename));
      String line;
      int lnum = 0;
      while ( (line = br.readLine()) != null) {
        StringTokenizer st = new StringTokenizer(line);
        String link = st.nextToken();
        System.out.println(++lnum + ":" + link);
        try {
          reader.read(link);
        }
        catch (Exception e) {
          continue;
        }
      }
    }
//    URLConnection conn = new URL(url).openConnection();
//    long t0 =  System.currentTimeMillis();
//    Document doc = reader.read(conn.getInputStream(),xmlBase);
//    BufferedReader in
//    = new BufferedReader(new InputStreamReader());


//    long t1 = System.currentTimeMillis()-t0;
    storage.close();

//    System.out.println("use time: "+t1);

/*
    OwlRdfWriter writer = new OwlRdfWriter();

    FileOutputStream fos = new FileOutputStream(outputPath);

    writer.write(fos,doc);
    fos.close();
/*
    if(doc instanceof Ontology){
      Ontology ont = (Ontology)doc;
      OntClass[] classes = ont.getAllClasses();
      System.out.println("\n\nClasses:\n");
      int l = classes.length;
      for(int i=0;i<l;i++){
        System.out.println(classes[i].getID().getId());
      }

      OntProperty[] properties = ont.getAllProperties();
      System.out.println("\n\nProperties:\n");
      l = properties.length;
      for(int i=0;i<l;i++){
        System.out.println(properties[i].getID().getId());
      }

      Individual[] individuals = ont.getAllIndividuals();
      System.out.println("\n\nIndividuals:\n");
      l = individuals.length;
      for(int i=0;i<l;i++){
        System.out.println(individuals[i].getID().getId());
      }
    }
*/

    }
    catch(Exception e){
      e.printStackTrace();
      System.err.println(e.getMessage());
      storage.forcedExit();
    }
    System.exit(0);
  }



}
