/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.core;

/**
 * encapsulating an assertion
 * @author Z. Pan
 * @version 1.0
 */

public abstract class Assertion {

  /**
   * Constructor
   */
  public Assertion() {
  }

  /**
   * get the subejct
   */
  public abstract ObjectId getSubject();

  /**
   * set the subject
   */
  public abstract void setSubject(ObjectId s);

  /**
   * get the obejct
   */
  public abstract ObjectId getObject();

  /**
   * set the object
   */
  public abstract void setObject(ObjectId o);

  /**
   * get the predicate
   */
  public abstract ObjectId getPredicate();

  /**
   * set the predicate
   */
  public abstract void setPredicate(ObjectId p);
}