

import edu.lehigh.swat.hawk.owl.*;
import edu.lehigh.swat.hawk.storage.simplememory.SimpleMemoryStorage;
import edu.lehigh.swat.hawk.storage.dlmemory.DlMemoryStorage;
import java.io.*;
import java.net.*;
import edu.lehigh.swat.hawk.core.*;
/**
 * test case
 * @author Z. Pan
 * @version 1.0
 */
public class TestSimple {

  public TestSimple() {
  }

  public static void main(String[] args) {
    try{
      if(args.length!=3){
        System.out.println("Usage: java edu.lehigh.swat.hawk.testSimple url xmlBase outputPath");
      }
    String url = args[0];
    String xmlBase = args[1];
    String outputPath = args[2];
    TestSimple testSimple1 = new TestSimple();
//    DlMemoryStorage storage = new DlMemoryStorage();
    SimpleMemoryStorage storage = new SimpleMemoryStorage();
    OwlRdfReader reader = new OwlRdfReader(storage);
//    reader.setLoadImports(true);
    URLConnection conn = new URL(url).openConnection();
//    long t0 =  System.currentTimeMillis();
//    Document doc = reader.read(conn.getInputStream(),xmlBase);
//    BufferedReader in
//    = new BufferedReader(new InputStreamReader(conn.getInputStream()));
    Document doc = reader.read(url);
//    long t1 = System.currentTimeMillis()-t0;

//    System.out.println("use time: "+t1);

//    FileOutputStream out = new FileOutputStream("serialization.dat");
 //   ObjectOutputStream s = new ObjectOutputStream(out);
//s.writeObject("Today");
 //   s.writeObject(doc);
//    s.flush();

//    s.close();
//   out.close();

//    doc = null;

//    FileInputStream ins = new FileInputStream("serialization.dat");
//    ObjectInputStream ois = new ObjectInputStream(ins);

//  doc = (Document)ois.readObject();

//    edu.lehigh.swat.hawk.storage.dlmemory.Ontology ont =
//       (edu.lehigh.swat.hawk.storage.dlmemory.Ontology) doc;

//    ont.computeSubsumptions("http://localhost:8080",null);

    OwlRdfWriter writer = new OwlRdfWriter();

    FileOutputStream fos = new FileOutputStream(outputPath);

    writer.write(fos,doc);
    fos.close();
/*
    if(doc instanceof Ontology){
      Ontology ont = (Ontology)doc;
      OntClass[] classes = ont.getAllClasses();
      System.out.println("\n\nClasses:\n");
      int l = classes.length;
      for(int i=0;i<l;i++){
        System.out.println(classes[i].getID().getId());
      }
/*
      OntProperty[] properties = ont.getAllProperties();
      System.out.println("\n\nProperties:\n");
      l = properties.length;
      for(int i=0;i<l;i++){
        System.out.println(properties[i].getID().getId());
      }

      Individual[] individuals = ont.getAllIndividuals();
      System.out.println("\n\nIndividuals:\n");
      l = individuals.length;
      for(int i=0;i<l;i++){
        System.out.println(individuals[i].getID().getId());
      }

    }
*/

    }
    catch(Exception e){
      System.err.println(e.getMessage());
      e.printStackTrace();
    }
    System.exit(0);
  }
}
